<template>
	<view class="uni-container">
		<uni-nav-bar dark :fixed="true" shadow background-color="#007AFF" status-bar left-icon="left" left-text="返回"
			title="新增 数据字典" @clickLeft="back" />
		<uni-card><uni-forms ref="form" :model="formData" validate-trigger="submit" err-show-type="toast">
			<uni-forms-item name="dictName" label="字典名称">
				<uni-easyinput placeholder="字典名称" v-model="formData.dictName" trim="both"></uni-easyinput>
			</uni-forms-item>
			<uni-forms-item name="dictCode" label="字典编码">
				<uni-easyinput placeholder="字典编码" v-model="formData.dictCode" trim="both"></uni-easyinput>
			</uni-forms-item>
			<uni-forms-item name="description" label="描述">
				<uni-easyinput placeholder="描述" v-model="formData.description" trim="both"></uni-easyinput>
			</uni-forms-item>
			<uni-forms-item name="delFlag" label="删除状态">
				<uni-easyinput placeholder="删除状态" type="number" v-model="formData.delFlag"></uni-easyinput>
			</uni-forms-item>
			<!-- <uni-forms-item name="createBy" label="创建人">
				<uni-easyinput placeholder="创建人" v-model="formData.createBy" trim="both"></uni-easyinput>
			</uni-forms-item>
			<uni-forms-item name="updateBy" label="更新人">
				<uni-easyinput placeholder="更新人" v-model="formData.updateBy" trim="both"></uni-easyinput>
			</uni-forms-item>
			<uni-forms-item name="updateTime" label="更新时间">
				<uni-datetime-picker v-model="formData.updateTime"></uni-datetime-picker>
			</uni-forms-item>
			<uni-forms-item name="createTime" label="创建时间">
				<uni-datetime-picker v-model="formData.createTime"></uni-datetime-picker>
			</uni-forms-item> -->
			<view class="uni-button-group">
				<button type="primary" class="uni-button" @click="submit">提交</button>
			</view>
		</uni-forms></uni-card>
	</view>
</template>

<script>
	import {
		validator
	} from '../../js_sdk/validator/ngTools_Dict.js';
	import {
		store,
		mutations
	} from '@/uni_modules/uni-id-pages/common/store.js'
	const db = uniCloud.database();
	const dbCollectionName = 'ngTools_Dict';

	function getValidator(fields) {	
		let result = {}
		for (let key in validator) {	
			if (fields.indexOf(key) > -1) {
				result[key] = validator[key]
			}
		}
		return result
	}



	export default {
		data() {
			let formData = {
				"dictName": "",
				"dictCode": "",
				"description": "",
				"delFlag": 0,
				"createBy": "",
				"updateBy": "",
				"updateTime": "",
				"createTime": ""
			}
			return {
				formData,
				formOptions: {},
				rules: {
					...getValidator(Object.keys(formData))
				}
			}
		},
		onReady() {			
			this.$refs.form.setRules(this.rules)
		},
		computed: {
			userInfo() {
				return store.userInfo
			},
			hasLogin() {
				return store.hasLogin
			},
			// #ifdef APP-PLUS
			appVersion() {
				return getApp().appVersion
			},
			// #endif
			appConfig() {
				return getApp().globalData.config
			}
		},
		methods: {
			back() {
				uni.navigateBack({
					delta: 1
				})
			},
			/**
			 * 验证表单并提交
			 */
			submit() {
				uni.showLoading({
					mask: true
				})
				this.$refs.form.validate().then((res) => {
					console.log(res)
					return this.submitForm(res)
				}).catch(() => {}).finally(() => {
					uni.hideLoading()
				})
			},

			/**
			 * 提交表单
			 */
			submitForm(value) {
				console.log(JSON.stringify(value));
				value.createBy=store.userInfo.nickname;
				value.createTime=new Date().toLocaleDateString()+" "+ new Date().toLocaleTimeString();
				// 使用 clientDB 提交数据
				return db.collection(dbCollectionName).add(value).then((res) => {
					uni.showToast({
						icon: 'none',
						title: '新增成功'
					})
					this.getOpenerEventChannel().emit('refreshData')
					setTimeout(() => uni.navigateBack(), 500)
				}).catch((err) => {
					uni.showModal({
						content: err.message || '请求服务失败',
						showCancel: false
					})
				})
			}
		}
	}
</script>

<style>
	.uni-container {
		padding: 0px;
	}

	.uni-input-border,
	.uni-textarea-border {
		width: 100%;
		font-size: 14px;
		color: #666;
		border: 1px #e5e5e5 solid;
		border-radius: 5px;
		box-sizing: border-box;
	}

	.uni-input-border {
		padding: 0 10px;
		height: 35px;

	}

	.uni-textarea-border {
		padding: 10px;
		height: 80px;
	}

	.uni-button-group {
		margin-top: 50px;
		/* #ifndef APP-NVUE */
		display: flex;
		/* #endif */
		justify-content: center;
	}

	.uni-button {
		width: 184px;
	}
</style>